/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

/**
 * @file pbind.c BFA FC Persistent target binding
 */

#include <cs/bfa_debug.h>
#include <cs/bfa_q.h>
#include <bfa_os_inc.h>
#include <bfa_os.h>
#include <log/bfa_log_hal.h>

/**
 * @ig cs_debug_api
 * @{
 */

/**
 * 	@brief
 */
void
bfa_panic(int line, char *file, char *panicstr)
{
	bfa_log(NULL, BFA_LOG_HAL_PANIC, file, line, panicstr);
	bfa_os_panic();
}

int
bfa_q_is_on_q_func(bfa_q_t *q, bfa_q_t *qe)
{
	bfa_q_t        *tqe;

	tqe = bfa_q_next(q);
	while (tqe != q) {
		if (tqe == qe)
			return (1);
		tqe = bfa_q_next(tqe);
		if (tqe == NULL)
			break;
	}
	return (0);
}

/**
 * @}
 */
