/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

/*
 *  File Name:      bfa_log_module.c
 *
 *  Description:
 *
 *  The log messages defined in each XML files will be converted to a C code
 *  style message file. The message file will be named the same as XML file.
 *
 *  These coded instructions and statements contain unpublished trade
 *  secrets and proprietary information.  They are protected by federal
 *  copyright law and by trade secret law, and may not be disclosed to
 *  third parties or used, copied, or duplicated in any form, in whole
 *  or in part, without the prior written consent of Brocade Communications.
 *
 */
#include <cs/bfa_log.h>
#include <log/bfa_log_fcs.h>
#include <log/bfa_log_hal.h>
#include <log/bfa_log_linux.h>
#include <log/bfa_log_wdrv.h>

#include <defs/bfa_defs_aen.h>
#include <aen/bfal_aen_adapter.h>
#include <aen/bfal_aen_audit.h>
#include <aen/bfal_aen_ioc.h>
#include <aen/bfal_aen_itnim.h>
#include <aen/bfal_aen_lport.h>
#include <aen/bfal_aen_port.h>
#include <aen/bfal_aen_rport.h>


bfa_log_msgdef_t bfa_log_msg_array[] = {
#include <log/bfa_log_fcs.msg>
#include <log/bfa_log_hal.msg>
#include <log/bfa_log_linux.msg>
#include <log/bfa_log_wdrv.msg>

#include <aen/bfal_aen_adapter.msg>
#include <aen/bfal_aen_audit.msg>
#include <aen/bfal_aen_ioc.msg>
#include <aen/bfal_aen_itnim.msg>
#include <aen/bfal_aen_lport.msg>
#include <aen/bfal_aen_port.msg>
#include <aen/bfal_aen_rport.msg>
	{0, 0, 0, "", "", 0, 0}
	,
};
