/* 
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 * 
 * See LICENSE.bfa for copyright and licensing details.
 */
/**
 * @brief
 * Contains declarations all OS Specific files needed for BFA layer
 */

#ifndef __BFA_OS_INC_H__
#define __BFA_OS_INC_H__

#ifndef __KERNEL__
#include <stdint.h>
#else
#include <linux/types.h>

#include "bfa_os.h"
#endif

typedef int boolean_t;

/**
 * For current time stamp, OS API will fill-in
 */
typedef struct {
	uint32_t	tv_sec;		/*!< seconds        */
	uint32_t	tv_usec;	/*!< microseconds   */
} bfa_timeval_t;

#endif /* __BFA_OS_INC_H__ */
