/*
 * Brocade Fibre Channel HBA Driver
 * Copyright (c) 2006-2007 Brocade Communications Systems, Inc.
 * All rights reserved.
 */
#include <linux/wait.h>		/* wake_up() */
#include <linux/fs.h>		/* kill_fasync() */
#include "bfad_aen_cb.h"

/**
 * @dg aen2bfad_api AEN module ==> Base Linux interface
 * @{
 */

/**
 * @brief BFAD callback function provided for AEN to inform arrival of a new event
 * @param[in] bfad  - Linux driver IOC instance ptr
 * @return          None
 */
void
bfad_aen_cb_notify(bfad_t *bfad)
{
	wake_up(&bfad_aen_readq);
	if (fasync_enabled)
		kill_fasync(&bfad_aen_asyncq, SIGIO, POLL_IN);
}

/**
 * @}
 */
