/* 
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 * 
 * See LICENSE.bfa for copyright and licensing details.
 */

/**
 * @file bfad_os.c Linux driver OS specific calls.
 */

#include "bfa_os_inc.h"
#include "bfad_drv.h"

/**
 * @dg OS_funcs BFA OS service functions
 * @{
 */

/*
 * Register access
 */
int
bfa_os_get_dev_regbase(bfad_t *bfad, int bar_num)
{
	return 0;
}

/*
 * DMA Sync
 */
int
bfa_os_dma_sync(void *bfad)
{
	return 0;
}

/*
 * Memory Allocation/Deallocation
 */

int
bfa_os_dma_alloc(void *bfad)
{
	return 0;
}

int
bfa_os_dma_free(void *bfad)
{
	return 0;
}

/*
 * Memory barrier
 */
int
bfa_os_MWB(void *bfad)
{
	return 0;
}

/*
 * Synchronization
 */

/*
 * Timer
 */

void
bfa_os_gettimeofday(bfa_timeval_t *tv)
{
	struct timeval  tmp_tv;

	do_gettimeofday(&tmp_tv);
	tv->tv_sec = (uint32_t) tmp_tv.tv_sec;
	tv->tv_usec = (uint32_t) tmp_tv.tv_usec;
}

uint32_t
bfa_os_get_instance_id(bfad_t *bfad)
{
	return (bfad->inst_no);
}


void
bfa_os_printf(struct bfa_log_mod_s *log_mod, uint32_t msg_id, const char *fmt, ...)
{
	va_list ap;
	#define BFA_STRING_256	256
	char tmp[BFA_STRING_256];

	va_start(ap, fmt);
	vsnprintf(tmp, sizeof(tmp), fmt, ap);
	va_end(ap);

	printk(tmp);
}

/**
 * @}
 */
