/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

/**
 * @file bfa_fcs_pport.c BFA FCS PPORT ( physical port )
 */

#include <fcs/bfa_fcs.h>
#include <hal/bfa_hal_pport.h>
#include <fcs/bfa_fcs_fabric.h>
#include <cs/bfa_stats.h>
#include "fcs_trcmod.h"
#include "fcs.h"
#include "fcs_fabric.h"

BFA_TRC_FILE(FCS, PPORT);

static void
bfa_fcs_pport_event_handler(void *cbarg, bfa_pport_event_t event)
{
	bfa_fcs_t      *fcs = cbarg;

	bfa_trc(fcs, event);

	switch (event) {
	case BFA_PPORT_LINKUP:
		bfa_fcs_fabric_link_up(&fcs->fabric);
		break;

	case BFA_PPORT_LINKDOWN:
		bfa_fcs_fabric_link_down(&fcs->fabric);
		break;

	case BFA_PPORT_TRUNK_LINKDOWN:
		bfa_assert(0);
		break;

	default:
		bfa_assert(0);
	}
}

void
bfa_fcs_pport_modinit(bfa_fcs_t *fcs)
{
	bfa_hal_pport_event_register(fcs->hal, bfa_fcs_pport_event_handler,
				     fcs);
}

void
bfa_fcs_pport_modexit(bfa_fcs_t *fcs)
{
	bfa_fcs_modexit_comp(fcs);
}
