/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#include <hal/bfa_hal.h>
#include <hal/bfa_hal_timer.h>
#include <hal/bfa_hal_fcxp.h>
#include <hcb/bfa_hcb_fcxp.h>
#include <fcs/bfa_fcs_port.h>
#include <fcs/bfa_fcs_port.h>
#include "fcs_port.h"
#include "fcs_rport.h"
#include "port_priv.h"

/**
 * @file fab.c port fab implementation.
 */

/**
 * @dg bfa_fcs_port_fab_public port fab public functions
 * @{
 */

/**
 * @brief
 *   Called by port to initialize fabric services of the base port.
 */
void
bfa_fcs_port_fab_init(bfa_fcs_port_t *port)
{
	bfa_fcs_port_ns_init(port);
	bfa_fcs_port_scn_init(port);
	bfa_fcs_port_ms_init(port);
}

/**
 * @brief
 *   Called by port to notify transition to online state.
 */
void
bfa_fcs_port_fab_online(bfa_fcs_port_t *port)
{
	bfa_fcs_port_ns_online(port);
	bfa_fcs_port_scn_online(port);
}

/**
 * @brief
 *   Called by port to notify transition to offline state.
 */
void
bfa_fcs_port_fab_offline(bfa_fcs_port_t *port)
{
	bfa_fcs_port_ns_offline(port);
	bfa_fcs_port_scn_offline(port);
	bfa_fcs_port_ms_offline(port);
}
