/*
 * Copyright (c) 2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */
#include <hal/bfa_hal.h>
#include <hcb/bfa_hcb.h>
#include <defs/bfa_defs_pci.h>
#include <cs/bfa_debug.h>
#include <hal_ioc.h>

extern bfa_hal_mod_t hal_mod_flash;
extern bfa_hal_mod_t hal_mod_diag;
extern bfa_hal_mod_t hal_mod_sgpg;
extern bfa_hal_mod_t hal_mod_pport;
extern bfa_hal_mod_t hal_mod_fcxp;
extern bfa_hal_mod_t hal_mod_uf;
extern bfa_hal_mod_t hal_mod_rport;
extern bfa_hal_mod_t hal_mod_fcpim;

/**
 * HAL module list terminated by NULL
 */
bfa_hal_mod_t *hal_mods[] = {
	&hal_mod_flash,
	&hal_mod_diag,
	&hal_mod_sgpg,
	&hal_mod_pport,
	&hal_mod_fcxp,
	&hal_mod_uf,
	&hal_mod_rport,
	&hal_mod_fcpim,
	NULL
};

/**
 * Message handlers for various modules.
 */
bfa_int_func_t  hal_isrs[BFA_MC_MAX] = {
	bfa_hal_isr_unhandled,	/* NONE */
	bfa_hal_isr_unhandled,	/* BFA_MC_IOC */
	bfa_hal_pport_isr,	/* BFA_MC_PORT */
	bfa_hal_flash_intr,	/* BFA_MC_FLASH */
	bfa_hal_uf_isr,		/* BFA_MC_UF */
	bfa_hal_fcxp_isr,	/* BFA_MC_FCXP */
	bfa_hal_rport_isr,	/* BFA_MC_RPORT */
	bfa_hal_itnim_isr,	/* BFA_MC_ITNIM */
	bfa_hal_isr_unhandled,	/* BFA_MC_IOIM_READ */
	bfa_hal_isr_unhandled,	/* BFA_MC_IOIM_WRITE */
	bfa_hal_isr_unhandled,	/* BFA_MC_IOIM_IO */
	bfa_hal_ioim_isr,	/* BFA_MC_IOIM */
	bfa_hal_ioim_good_comp_isr,	/* BFA_MC_IOIM_IOCOM */
	bfa_hal_isr_unhandled,	/* NONE */
	bfa_hal_isr_unhandled,	/* NONE */
	bfa_hal_isr_unhandled,	/* NONE */
	bfa_hal_tskim_isr,	/* BFA_MC_TSKIM */
	diag_intr,		/* BFA_MC_DIAG */
	bfa_hal_isr_unhandled,	/* BFA_MC_IP */
	bfa_hal_isr_unhandled,	/* BFA_MC_SBOOT */
	bfa_hal_isr_unhandled,	/* BFA_MC_SB */
	bfa_hal_isr_unhandled,	/* --------- */
	bfa_hal_isr_unhandled,	/* --------- */
};
