/*
 * Copyright (c) 2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __HAL_FLASH_H__
#define __HAL_FLASH_H__

#include <cs/bfa_sm.h>
#include <hal/bfa_hal_flash.h>
#include <fwi/bfa_fwi_flash.h>

typedef struct {
	bfa_hal_t	*hal;		/* !< back pointer to HAL */
	uint32_t        type;		/* !< partition type */
	uint32_t        instance;	/* !< partition instance */
	uint32_t        op_busy;	/* !< operation busy flag */
	uint32_t        residue;	/* !< residual length */
	uint32_t        offset;		/* !< offset */
	bfa_status_t    status;		/* !< status */
	uint8_t		*dbuf_kva;	/* !< dma buf virtual address */
	uint64_t        dbuf_pa;	/* !< dma buf physical address */
	bfa_hal_reqq_wait_t reqq_wait;	/* !< to wait for room in reqq */
	bfa_hcb_flash_t	cbfn;		/* !< user callback function */
	void		*cbarg;		/* !< user callback arg */
	uint8_t		*ubuf;		/* !< user supplied buffer */
	bfa_hcb_qe_t	hcb_qe;		/* !< comp: HAL callback qelem */
	uint32_t	addr_off;	/* !< partition address offset */
} bfa_hal_flash_mod_t;

#define BFA_HAL_FLASH_MOD(__hal)	(&(__hal)->modules.flash_mod)

void	bfa_hal_flash_intr(bfa_hal_t *hal, bfa_msg_t *msg);
#endif /* __HAL_FLASH_H__ */
