/*
 * Copyright (c) 2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __HAL_MODULES_H__
#define __HAL_MODULES_H__

#include "hal_uf.h"
#include "hal_port.h"
#include "hal_rport.h"
#include "hal_fcxp.h"
#include "hal_diag.h"
#include "hal_fcpim.h"
#include "hal_flash.h"
#include "hal_sboot.h"

typedef struct {
	bfa_hal_pport_t		pport;		/*!< physical port module */
	bfa_hal_fcxp_mod_t	fcxp_mod;	/*!< fcxp module */
	bfa_hal_uf_mod_t	uf_mod;		/*!< unsolicited frame module */
	bfa_hal_rport_mod_t	rport_mod;	/*!< remote port module */
	bfa_hal_fcpim_mod_t	fcpim_mod;	/*!< FCP initiator module */
	bfa_hal_sgpg_mod_t	sgpg_mod;	/*!< SG page module */
	bfa_hal_diag_mod_t	diag_mod;	/*!< diagnostics module */
	bfa_hal_flash_mod_t	flash_mod;	/*!< flash module */
	bfa_hal_sboot_t		sboot;		/*!< SAN boot services module */
} bfa_hal_modules_t;
#endif /* __HAL_MODULES_H__ */
