/*
 * Copyright (c) 2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

/**
 * @file BFA HAL register access macros.
 */

#ifndef __HAL_REG_H__
#define __HAL_REG_H__

typedef struct {
	bfa_os_addr_t   intr_status;
	bfa_os_addr_t   intr_mask;
	bfa_os_addr_t   hfn_mbox_cmd;
	bfa_os_addr_t   hfn_mbox;
	bfa_os_addr_t   lpu_mbox_cmd;
	bfa_os_addr_t   lpu_mbox;
	bfa_os_addr_t   lpu_ioc_status;
	bfa_os_addr_t   cpe_q_pi[BFA_IOC_MAX_CQS];
	bfa_os_addr_t   cpe_q_ci[BFA_IOC_MAX_CQS];
	bfa_os_addr_t   cpe_q_depth[BFA_IOC_MAX_CQS];
	bfa_os_addr_t   rme_q_ci[BFA_IOC_MAX_CQS];
	bfa_os_addr_t   rme_q_pi[BFA_IOC_MAX_CQS];
	bfa_os_addr_t   rme_q_depth[BFA_IOC_MAX_CQS];
	bfa_os_addr_t   pss_ctl_reg;
	bfa_os_addr_t   app_pll_400_ctl_reg;
	bfa_os_addr_t   app_pll_212_ctl_reg;
	bfa_os_addr_t   host_sem0_reg;
	bfa_os_addr_t   host_sem1_reg;
	bfa_os_addr_t   host_sem2_reg;
	bfa_os_addr_t   host_sem3_reg;
	bfa_os_addr_t   host_page_num_fn;
	bfa_os_addr_t   heartbeat;
	bfa_os_addr_t   ioc_fwstate;
	bfa_os_addr_t   smem_page_start;
} bfa_chip_regs_t;

#define bfa_hal_reg_read(_raddr)	bfa_os_reg_read(_raddr)
#define bfa_hal_reg_write(_raddr, _val)	bfa_os_reg_write(_raddr, _val)
#define bfa_hal_mem_read(_raddr, _off)	bfa_os_mem_read(_raddr, _off)
#define bfa_hal_mem_write(_raddr, _off, _val)	\
					bfa_os_mem_write(_raddr, _off, _val)
#endif /* __HAL_REG_H__ */
