/*
 * Copyright (c) 2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __HAL_RPORT_H__
#define __HAL_RPORT_H__

#include <hal/bfa_hal_rport.h>

#define BFA_HAL_RPORT_MIN	64

typedef struct bfa_hal_rport_mod {
	bfa_hal_rport_t	*rps_list;	/*!< list of rports	*/
	bfa_q_t		rp_free_q;	/*!< free hal_rports	*/
	bfa_q_t		rp_active_q;	/*!< free hal_rports 	*/
	uint16_t	num_rports;	/*!< number of rports	*/
} bfa_hal_rport_mod_t;

#define BFA_HAL_RPORT_MOD(__hal)	(&(__hal)->modules.rport_mod)

/**
 * Convert rport tag to RPORT
 */
#define BFA_HAL_RPORT_FROM_TAG(__hal, _tag)				\
	(BFA_HAL_RPORT_MOD(__hal)->rps_list +				\
	 ((_tag) & (BFA_HAL_RPORT_MOD(__hal)->num_rports - 1)))

/*
 * external functions
 */
void	bfa_hal_rport_isr(bfa_hal_t *hal, bfa_msg_t *msg);
#endif /* __HAL_RPORT_H__ */
