/*
 * Copyright (c) 2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __HAL_SBOOT_H__
#define __HAL_SBOOT_H__

#include <hal/bfa_hal_sboot.h>
#include <fwi/bfa_fwi_sboot.h>

typedef struct {
	bfa_sboot_config_t	*sbcfg;
	bfa_fwi_sboot_rport_t	*rplist;
	bfa_fwi_sboot_lun_t	*lunlist;
	bfa_hal_dma_t		sbcfg_dma;
	bfa_hal_dma_t		rplist_dma;
	bfa_hal_dma_t		lunlist_dma;
	uint16_t		num_sboot_tgts;
	uint16_t		num_sboot_luns;
} bfa_hal_sboot_t;

/*
 * external functions
 */
void	bfa_hal_sboot_isr(bfa_hal_t *hal, bfa_msg_t *msg);

#endif /* __HAL_SBOOT_H__ */
