/*
 * Copyright (c) 2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */
#ifndef __HAL_UF_H__
#define __HAL_UF_H__

#include <cs/bfa_sm.h>
#include <hal/bfa_hal_uf.h>
#include <fwi/bfa_fwi_uf.h>

typedef struct bfa_hal_uf_mod {
	bfa_hal_t	*hal;		/*!< back pointer to HAL */
	bfa_hal_uf_t	*uf_list;	/*!< array of UFs */
	uint16_t	num_ufs;	/*!< num unsolicited rx frames */
	bfa_q_t		uf_free_q;	/*!< free UFs */
	bfa_q_t		uf_posted_q;	/*!< UFs posted to IOC */
	bfa_hal_uf_buf_t *uf_pbs_kva;	/*!< list UF bufs request pld */
	uint64_t	uf_pbs_pa;	/*!< phy addr for UF bufs */
	bfa_fwi_uf_buf_post_t *uf_buf_posts;
					/*!< pre-built UF post msgs */
	bfa_hcb_uf_recv_t ufrecv;	/*!< uf recv handler function */
	void		*cbarg;		/*!< uf receive handler arg */
} bfa_hal_uf_mod_t;

#define BFA_HAL_UF_MOD(__hal)	(&(__hal)->modules.uf_mod)

#define ufm_pbs_pa(_ufmod, _uftag)	\
	((_ufmod)->uf_pbs_pa + sizeof(bfa_hal_uf_buf_t) * (_uftag))

void	bfa_hal_uf_isr(bfa_hal_t *hal, bfa_msg_t *msg);

#endif /* __HAL_UF_H__ */
