/*
 * Copyright (c) 2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

/**
 * @file bfasm.h State machine defines
 */

#ifndef __BFA_SM_H__
#define __BFA_SM_H__

typedef void (*bfa_sm_t)(void *sm, int event);

#define bfa_sm_set_state(_sm, _state)			\
	(_sm)->sm = (bfa_sm_t)(_state)
#define bfa_sm_send_event(_sm, _event)			\
	(_sm)->sm((_sm), (_event))
#define bfa_sm_get_state(_sm)			((_sm)->sm)
#define bfa_sm_cmp_state(_sm, _state)	((_sm)->sm == (bfa_sm_t)(_state))

/**
 * For converting from state machine function to state encoding.
 */
typedef struct {
	bfa_sm_t	sm;		/*!< state machine function	*/
	int			state;	/*!< state machine encoding	*/
	char		*name;	/*!< state name for display	*/
} bfa_sm_table_t;
#define BFA_SM(_sm)	((bfa_sm_t)(_sm))

int bfa_sm_to_state(bfa_sm_table_t *smt, bfa_sm_t sm);

#endif
