/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_DEFS_AEN_H__
#define __BFA_DEFS_AEN_H__

#include <defs/bfa_defs_types.h>
#include <defs/bfa_defs_ioc.h>
#include <defs/bfa_defs_adapter.h>
#include <defs/bfa_defs_port.h>
#include <defs/bfa_defs_lport.h>
#include <defs/bfa_defs_rport.h>
#include <defs/bfa_defs_itnim.h>
#include <defs/bfa_defs_itntm.h>
#include <defs/bfa_defs_ipfc.h>
#include <defs/bfa_defs_audit.h>

typedef enum {
	BFA_AEN_CAT_ADAPTER 	= 1,
	BFA_AEN_CAT_PORT 	= 2,
	BFA_AEN_CAT_LPORT 	= 3,
	BFA_AEN_CAT_RPORT 	= 4,
	BFA_AEN_CAT_ITNIM 	= 5,
	BFA_AEN_CAT_ITNTM 	= 6,
	BFA_AEN_CAT_IPFC 	= 7,
	BFA_AEN_CAT_AUDIT 	= 8,
	BFA_AEN_CAT_IOC 	= 9
} bfa_aen_category_t;

typedef int     bfa_aen_event_t;

#pragma pack(1)
typedef union {
	bfa_adapter_aen_data_t 	adapter;
	bfa_port_aen_data_t 	port;
	bfa_lport_aen_data_t 	lport;
	bfa_rport_aen_data_t 	rport;
	bfa_itnim_aen_data_t 	itnim;
	bfa_audit_aen_data_t 	audit;
	bfa_ioc_aen_data_t 	ioc;
} bfa_aen_data_t;

typedef struct {
	bfa_aen_category_t 	aen_category;
	bfa_aen_event_t 	aen_type;
	bfa_aen_data_t  	aen_data;
	bfa_timeval_t   	aen_tv;
	int32_t         	bfad_num;
	int32_t         	rsvd[1];
} bfa_aen_entry_t;
#pragma pack()

#endif /* __BFA_DEFS_AEN_H__ */
