/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

/**
 * @file bfa_fcb_vport.h BFA FCS virtual port driver interfaces
 */

#ifndef __BFA_FCB_VPORT_H__
#define __BFA_FCB_VPORT_H__

/**
 * @dg fcs_vport_fcb Virtual port driver interfaces
 * @{
 */

/**
 * @brief Driver vport structure: opaque for BFA
 */
typedef struct bfad_vport_s bfad_vport_t;

/*
 * Callback functions from BFA FCS to driver
 */

/**
 * @brief
 * 	Completion callback for bfa_fcs_vport_delete().
 *
 * @param[in] vport_drv - driver instance of vport
 *
 * @return None
 */
void            bfa_fcb_vport_delete(bfad_vport_t *vport_drv);

/**
 * @}
 */

#endif /* __BFA_FCB_VPORT_H__ */
