/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

/**
 * @file bfa_fcs_fdmi.h BFA fcs fdmi module public interface
 */

#ifndef __BFA_FCS_FDMI_H__
#define __BFA_FCS_FDMI_H__
#include <bfa_os_inc.h>
#include <protocol/fdmi.h>

#define	BFA_FCS_FDMI_SUPORTED_SPEEDS  (FDMI_TRANS_SPEED_1G  | \
					FDMI_TRANS_SPEED_2G | \
					FDMI_TRANS_SPEED_4G | \
					FDMI_TRANS_SPEED_8G)

/*
* HBA Attribute Block : BFA internal representation. Note : Some variable
* sizes have been trimmed to suit BFA For Ex : Model will be "Brocade". Based
 * on this the size has been reduced to 16 bytes from the standard's 64 bytes.
 */
typedef struct bfa_fcs_fdmi_hba_attr_s {
	wwn_t           node_name;
	uint8_t         manufacturer[64];
	uint8_t         serial_num[64];
	uint8_t         model[16];
	uint8_t         model_desc[256];
	uint8_t         hw_version[8];
	uint8_t         driver_version[8];
	uint8_t         option_rom_ver[8];
	uint8_t         fw_version[8];
	uint8_t         os_name[256];
	uint32_t        max_ct_pyld;
} bfa_fcs_fdmi_hba_attr_t;

/*
 * Port Attribute Block
 */
typedef struct bfa_fcs_fdmi_port_attr_s {
	uint8_t         supp_fc4_types[32];	/* supported FC4 types */
	uint32_t        supp_speed;	/* supported speed */
	uint32_t        curr_speed;	/* current Speed */
	uint32_t        max_frm_size;	/* max frame size */
	uint8_t         os_device_name[256];	/* OS device Name */
	uint8_t         host_name[256];	/* host name */
} bfa_fcs_fdmi_port_attr_t;

#endif /* __BFA_FCS_FDMI_H__ */
