/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_FWI_UF_H__
#define __BFA_FWI_UF_H__

#include "bfa_fwi.h"

#pragma pack(1)

typedef enum {
	BFA_FWI_UF_H2I_BUF_POST = 1,
} bfa_fwi_uf_h2i_t;

typedef enum {
	BFA_FWI_UF_I2H_FRM_RCVD = BFA_I2HM(1),
} bfa_fwi_uf_i2h_t;

#define BFA_UF_MAX_SGES	2

typedef struct {
	bfa_mhdr_t      mh;	/*!< Common msg header */
	uint16_t        buf_tag;	/*!< buffer tag */
	uint16_t        buf_len;	/*!< total buffer length */
	bfa_sge_t       sge[BFA_UF_MAX_SGES];	/*!< buffer DMA SG elems */
} bfa_fwi_uf_buf_post_t;

typedef struct {
	bfa_mhdr_t      mh;	/*!< Common msg header */
	uint16_t        buf_tag;	/*!< buffer tag */
	uint16_t        rsvd;
	uint16_t        frm_len;	/*!< received frame length */
	uint16_t        xfr_len;	/*!< tranferred length */
} bfa_fwi_uf_frm_rcvd_t;

#pragma pack()

#endif /* __BFA_FWI_UF_H__ */
