/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */
#ifndef __BFA_HAL_IPFC_H__
#define __BFA_HAL_IPFC_H__

#include <hal/bfa_hal.h>

typedef struct bfad_pkt_s bfad_pkt_t;

/**
 * Packet receive status
 */
typedef enum {
	BFA_HAL_IPFC_STATUS_OK = 0,	/*!< good packet */
	BFA_HAL_IPFC_STATUS_PARTIAL = 1,	/*!< only partial frame is
						 *recvd */
	BFA_HAL_IPFC_STATUS_FLUSHED = 2,	/*!< driver requested return */
} bfa_hal_ipfc_status_t;

/*
 * bfa hal ipfc API functions
 */
void            bfa_hal_ipfc_meminfo(int npkts, bfa_hal_meminfo_t *meminfo);
void            bfa_hal_ipfc_attach(bfa_hal_t *hal, void *dipfc, int npkts,
				    bfa_hal_meminfo_t *meminfo);
void            bfa_hal_ipfc_detach(bfa_hal_t *hal);
void            bfa_hal_ipfc_postpkt(bfa_hal_t *hal, bfad_pkt_t *dpkt);
void            bfa_hal_ipfc_flushpkt(bfa_hal_t *hal, bfad_pkt_t *dpkt);
#endif /* __BFA_HAL_IPFC_H__ */
