/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_HAL_ITNIM_H__
#define __BFA_HAL_ITNIM_H__

#include <defs/bfa_defs_status.h>
#include <bfa_os_inc.h>
#include <cs/bfa_sm.h>
#include <hal/bfa_hal.h>
#include <hal/bfa_hal_rport.h>

/*
 * forward declarations
 */
typedef struct bfa_hal_itnim_s bfa_hal_itnim_t;

/*
 * bfa hal API functions
 */
bfa_hal_itnim_t *bfa_hal_itnim_create(bfa_hal_t *hal, bfa_hal_rport_t *rport,
				      void *itnim);
void            bfa_hal_itnim_delete(bfa_hal_itnim_t *itnim);
void            bfa_hal_itnim_online(bfa_hal_itnim_t *itnim,
				     bfa_boolean_t seq_rec);
void            bfa_hal_itnim_offline(bfa_hal_itnim_t *itnim);
void            bfa_hal_itnim_get_stats(bfa_hal_itnim_t *itnim,
			bfa_itnim_hal_stats_t *stats);
void		bfa_hal_itnim_clear_stats(bfa_hal_itnim_t *itnim);
void            bfa_hal_fcpim_mpio_mode_set(bfa_hal_t *hal,
				    bfa_boolean_t mpio_mode, uint16_t path_tov);
bfa_boolean_t   bfa_hal_fcpim_mpio_mode_get(bfa_hal_t *hal);
uint16_t	bfa_hal_fcpim_path_tov_get(bfa_hal_t *hal);

void            bfa_hal_fcpim_qdepth_set(bfa_hal_t *hal, uint16_t q_depth);
uint16_t   	bfa_hal_fcpim_qdepth_get(bfa_hal_t *hal);
#endif /* __BFA_HAL_ITNIM_H__ */
