/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */
#ifndef __BFA_HAL_TIMER_H__
#define __BFA_HAL_TIMER_H__

#include <cs/bfa_q.h>
#include <cs/bfa_sm.h>

struct bfa_hal_s;

/**
 * HAL timer data structure
 */
typedef struct {
	bfa_q_t         qe;
	void            (*timercb) (void *);
	void            *arg;
	int             timeout;	/**< in millisecs. */
} bfa_hal_timer_t;

/*
 * bfa hal timer API functions
 */
void            bfa_hal_timer_init(struct bfa_hal_s *hal);
void            bfa_hal_timer_start(struct bfa_hal_s *hal,
				    bfa_hal_timer_t *timer,
				    void (*timercb) (void *), void *arg,
				    unsigned int timeout);
void            bfa_hal_timer_stop(bfa_hal_timer_t *timer);
#endif /* __BFA_HAL_TIMER_H__ */
