/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */
#ifndef __BFA_HAL_TSKIM_H__
#define __BFA_HAL_TSKIM_H__

#include <cs/bfa_q.h>
#include <cs/bfa_sm.h>
#include <defs/bfa_defs_status.h>
#include <hal/bfa_hal.h>
#include <hcb/bfa_hcb_tskim.h>
#include <protocol/fcp.h>

/*
 * forward declaration
 */
typedef struct bfa_hal_tskim_s bfa_hal_tskim_t;

/*
 * bfa hal tskim API functions
 */
bfa_hal_tskim_t *bfa_hal_tskim_alloc(bfa_hal_t *hal, bfad_tskim_t *dtsk);
void            bfa_hal_tskim_free(bfa_hal_tskim_t *tskim);
void            bfa_hal_tskim_start(bfa_hal_tskim_t *tskim,
				    bfa_hal_itnim_t *itnim, lun_t lun,
				    fcp_tm_cmnd_t tm, uint8_t t_secs);
#endif /* __BFA_HAL_TSKIM_H__ */
