/*
 * Copyright (c)  2005-2008 Brocade Communications Systems, Inc.
 * All rights reserved
 * www.brocade.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

/**
 * @file bfa_hcb_tskim.h BFA HAL callbacks for initiator mode IO handling.
 */

#ifndef __BFA_HCB_TSKIM_H__
#define __BFA_HCB_TSKIM_H__

#include <hal/bfa_hal.h>
#include <fwi/bfa_fwi_tskim.h>

/*
 * forward declarations
 */
typedef struct bfad_tskim_s bfad_tskim_t;

/**
 * @dg bfa_hcb_tskim HAL initiator mode IO handling
 * @{
 */

/**
 * @brief
 * 		I/O completion notification.
 *
 * @param[in]		bfad			driver instance
 * @param[in]		dio			driver IO structure
 * @param[in]		tsk_status		Task management command
 *						completion status
 *
 * @return None
 */
void            bfa_hcb_tskim_done(void *bfad, bfad_tskim_t *dtsk,
				   bfa_tskim_status_t tsk_status);

/**
 * @}
 */

#endif /* __BFA_HCB_TSKIM_H__ */
