/*
 * Brocade Fibre Channel HBA Driver
 * Copyright (c) 2006-2007 Brocade Communications Systems, Inc.
 * All rights reserved.
 */

#ifndef __BFA_IOCTL_AEN_H__
#define __BFA_IOCTL_AEN_H__

#include "defs/bfa_defs_aen.h"

/**
 * This struct is between User space(BFAL) and Kernel space
 * @Param[out]      status      Return status from ioctl call
 * @Param[in]       bfad_num    BFA device instance number
 * @Param[in,out]   aen_list    User allocated aen_list empty array.
 *                              aen_list array with event data, if any.
 * @Param[in,out]   aen_count   aen_list array max size.
 *                              Number of events copied to aen_list.
 *                              (return value == passed value) ==>
 *					  call again for more events.
 *                              (return value < passed value) ==>
 *					 no more events present.
 */
typedef struct bfa_ioctl_aen_s {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	uint32_t        aen_count;
	bfa_boolean_t	block;
	bfa_aen_entry_t aen_list[1];	/* Must be the last one */
} bfa_ioctl_aen_t;

#endif /* __BFA_IOCTL_AEN_H__ */
