/*
 * Copyright (c) 2006-2007 Brocade Communications Systems, Inc.
 * All rights reserved.
 */

#ifndef __BFA_IOCTL_DIAG_H__
#define __BFA_IOCTL_DIAG_H__

#include <defs/bfa_defs_pom.h>
#include <defs/bfa_defs_tsensor.h>
#include <defs/bfa_defs_diag.h>

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	uint32_t        off;
	uint32_t        nwords;
	int             inst_no;
	uint32_t        rsvd1;
#ifdef _WINDOWS
	uint32_t        buf_ptr[1];
#else
	uint64_t        buf_ptr;
#endif
} bfa_ioctl_diag_regread_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	uint32_t        off;
	uint32_t        word;
	int             inst_no;
	uint32_t        rsvd1;
} bfa_ioctl_diag_regwrite_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        temp;
} bfa_ioctl_diag_get_temp_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_diag_post_result_t result;
} bfa_ioctl_diag_post_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd[3];
	uint32_t        pat;
	bfa_diag_memtest_result_t result;
	bfa_diag_memtest_t memtest;
} bfa_ioctl_diag_memtest_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_pport_opmode_t opmode;
	bfa_pport_speed_t speed;
	uint32_t        lpcnt;
	uint32_t        pat;
	bfa_diag_loopback_result_t result;
} bfa_ioctl_diag_loopback_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	uint32_t        cnt;
	uint32_t        pattern;
	bfa_diag_fwping_result_t result;
} bfa_ioctl_diag_fwping_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_pom_attr_t  pom;
} bfa_ioctl_diag_pom_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint8_t         static_data;
	uint8_t         rsvd;
	sfp_mem_t       sfp;
} bfa_ioctl_diag_sfp_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_diag_ledtest_t ledtest;
} bfa_ioctl_diag_led_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd; 
	bfa_boolean_t   beacon;
	bfa_boolean_t   link_e2e_beacon;
	uint32_t        second;
} bfa_ioctl_diag_beacon_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_boolean_t   beacon;
	uint16_t        vf_id;
	uint16_t        rsvd1;
	wwn_t           lpwwn;
	wwn_t           rpwwn;
} bfa_ioctl_diag_rport_t;

#endif
