/*
 * Copyright (c) 2006-2007 Brocade Communications Systems, Inc.
 * All rights reserved.
 */

#ifndef __BFA_IOCTL_FCPT_H__
#define __BFA_IOCTL_FCPT_H__

#define BFA_FCPT_MAX 4096

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           lpwwn;
	wwn_t           dpwwn;
	uint32_t        tsecs;
	boolean_t       cts;
	fc_cos_t        cos;
	uint32_t        rsvd;
	fchs_t          fchs;
	boolean_t       nport_nexus_needed;	/*!< If set, the fc passthru
						 *will be *sent only if the
						 *nport nexus exists *for
						 *the remote port */
	uint32_t        reqsz;
	uint32_t        rspsz;
	uint32_t        rsvd1;
#ifndef _WINDOWS
	uint64_t        reqbuf_ptr;
	uint64_t        rspbuf_ptr;
#else
	char            reqbuf_ptr[BFA_FCPT_MAX];
	char            rspbuf_ptr[1];
#endif
} bfa_ioctl_fcpt_t;

#endif
