/*
 * Copyright (c) 2006-2007 Brocade Communications Systems, Inc.
 * All rights reserved.
 */

#ifndef __BFA_IOCTL_FLASH_H__
#define __BFA_IOCTL_FLASH_H__

#include <defs/bfa_defs_flash.h>
#include <defs/bfa_defs_mfg.h>

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_flash_attr_t attr;
} bfa_ioctl_flash_attr_t;

/*
 * For FLASH_ERASE_PART, FLASH_UPDATE_PART, and FLASH_READ_PART IOCTLs
 */
typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_flash_part_type_t type;
	uint32_t        instance;
	uint64_t        buf_ptr;
	int             bufsz;
#ifdef _WINDOWS
	uint32_t        offset;
	char            buf[1];
#endif
} bfa_ioctl_flash_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_mfg_block_t mfgblk;
} bfa_ioctl_flash_mfg_t;

#endif
