/*
 * Copyright (c) 2006-2007 Brocade Communications Systems, Inc.
 * All rights reserved.
 */

#ifndef __BFA_IOCTL_IOC_H__
#define __BFA_IOCTL_IOC_H__

#include <defs/bfa_defs_ioc.h>
#include <defs/bfa_defs_pm.h>
#include <defs/bfa_defs_port.h>

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_port_role_t role;
} bfa_ioctl_ioc_cfg_pport_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_ioc_attr_t  ioc_attr;
} bfa_ioctl_ioc_attr_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_ioc_stats_t ioc_stats;
} bfa_ioctl_ioc_stats_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_ioc_intr_attr_t attr;
} bfa_ioctl_ioc_intr_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	char            serialnum[64];
	char            hwpath[32];
	char            adapter_hwpath[32];
	char            name[BFA_ADAPTER_SYM_NAME_LEN];
	char            port_name[BFA_ADAPTER_SYM_NAME_LEN];
	wwn_t           pwwn;
	wwn_t           nwwn;
} bfa_ioctl_ioc_info_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_pm_ds_t     power;
	uint32_t        rsvd1;
} bfa_ioctl_ioc_power_t;

typedef struct {
	uint32_t        cnt;	/* total number of ioc instances */
	uint32_t        rsvd;
	char            bm[256 / 8];	/* bit mask with instances positions */
} bfa_ioctl_ioc_get_inst_t;

typedef struct {
	bfa_status_t    status;
	uint32_t        version;
} bfa_ioctl_ioc_get_version_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	char            name[BFA_ADAPTER_SYM_NAME_LEN];
} bfa_ioctl_ioc_set_adapter_name_t;

#endif
