/*
 * Copyright (c) 2006-2007 Brocade Communications Systems, Inc.
 * All rights reserved.
 */

#ifndef __BFA_IOCTL_PORT_H__
#define __BFA_IOCTL_PORT_H__

#include <defs/bfa_defs_pport.h>

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_pport_attr_t attr;
} bfa_ioctl_port_attr_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_pport_stats_t stats;
} bfa_ioctl_port_stats_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_pport_topology_t topo;
	uint32_t        rsvd1;
} bfa_ioctl_port_cfg_topo_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_pport_speed_t speed;
	uint32_t        rsvd1;
} bfa_ioctl_port_cfg_speed_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	uint8_t         alpa;
	uint8_t         rsvd1[7];
} bfa_ioctl_port_alpa_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        maxfrsize;
} bfa_ioctl_port_cfg_maxfrsize_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint8_t         pp_bmap;
	uint8_t         rsvd;
} bfa_ioctl_port_trunk_t;

#endif
