/*
 * Copyright (c) 2006-2007 Brocade Communications Systems, Inc.
 * All rights reserved.
 */

#ifndef __BFA_IOCTL_RPORT_H__
#define __BFA_IOCTL_RPORT_H__

#include <defs/bfa_defs_rport.h>

/*
 * For RPORT_ADD and RPORT_REMOVE IOCTLs
 */
typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           pwwn;
	wwn_t           rpwwn;
} bfa_ioctl_rport_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           pwwn;
	wwn_t           rpwwn;
	bfa_rport_attr_t attr;
} bfa_ioctl_rport_attr_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           pwwn;
	wwn_t           rpwwn;
	bfa_rport_stats_t stats;
} bfa_ioctl_rport_stats_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           pwwn;
	wwn_t           rpwwn;
} bfa_ioctl_rport_reset_stats_t;

typedef struct {
	bfa_status_t	status;
    	uint16_t	bfad_num;
    	uint16_t	vf_id;
    	wwn_t		pwwn;
    	wwn_t 		rpwwn;
    	uint32_t 	host;
    	uint32_t 	bus;
    	uint32_t 	target;
    	uint32_t 	lun;
} bfa_ioctl_rport_scsi_addr_t;
#endif
