/*
 * Copyright (c) 2006-2007 Brocade Communications Systems, Inc.
 * All rights reserved.
 */

#ifndef __BFA_IOCTL_SCSI_H__
#define __BFA_IOCTL_SCSI_H__

#include <protocol/scsi.h>

#define BFA_SNSBUF_MAX 256

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           lpwwn;
	wwn_t           rpwwn;
	lun_t           lun;
	scsi_cdb_t      cdb;
	int             write;
	uint32_t        iosz;
	uint8_t         rsvd1[3];
	uint8_t         scsi_status;
	uint32_t        snssz;
#ifndef _WINDOWS
	uint64_t        iobuf_ptr;
	uint64_t        snsbuf_pt;
#else
	char            snsbuf_pt[BFA_SNSBUF_MAX];
	char            iobuf_ptr[1];
#endif
} bfa_ioctl_scsi_t;

#endif
