/*
 * Copyright (c) 2006-2007 Brocade Communications Systems, Inc.
 * All rights reserved.
 */

#ifndef __BFA_IOCTL_VPORT_H__
#define __BFA_IOCTL_VPORT_H__

#include <defs/bfa_defs_vport.h>

/*
 * For VPORT_DEL, VPORT_START, VPORT_STOP IOCTLs
 */
typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           vpwwn;
} bfa_ioctl_vport_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           vpwwn;
	bfa_port_cfg_t  port_cfg;
} bfa_ioctl_vport_create_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           vpwwn;
	bfa_vport_attr_t vport_attr;
} bfa_ioctl_vport_attr_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           vpwwn;
	bfa_vport_stats_t vport_stats;
} bfa_ioctl_vport_stats_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           vpwwn;
} bfa_ioctl_vport_reset_stats_t;

#endif
